%%
%   function approximationrectangles
%
%   This function enables the visualisation of the approximation rectangles
%   in the magnitude-phase stability diagrams for constant frequency.
%   Furhtermore, the line on the frequency corresponding to the visible 
%   magnitude-phase stability diagram for constant frequency can be
%   visualised in the stability-Bode plots.
%
%   input from data:    - plot   : contains flags for the plotting of
%                                   rectangles or lines
%                       - mapped : flag that indicates whether a stability-
%                                   mapping exists.
%                       - handles: contains elements in main GUI
%
%%



function approximationrectangles(action,hObject,eventdata,handles)
global data;

switch action
    case 'rectangles'
        % Visualise rectangles in magnitude-phase stability diagrams
        if(data.plot.rectanglesFlag == 0)
            data.plot.rectanglesFlag = 1;
        else
            data.plot.rectanglesFlag = 0;
        end
        
        if(data.mapped == 1)
            plotMPOmega(action,hObject,eventdata,handles);
        end
        
    case 'showinbode'
        % Visualise lines in stability-Bode diagram
        if(data.plot.showinbodeFlag == 0)
            data.plot.showinbodeFlag = 1;
        else
            data.plot.showinbodeFlag = 0;
            try
                delete(data.plot.temp.linemag);
                delete(data.plot.temp.linephase)
            catch
            end
        end
        
        if(data.mapped == 1 && data.plot.showinbodeFlag == 1)
            plotLineOnFreq();
        else
            set(data.handles.showinbode,'Value',0);
        end
end

return
