%%
%
%
%%
function loadSettings(action,hObject,eventdata,handles)
global data
otherButtons('disable');

delete(allchild(data.handles.MagPhaseperOmega));
delete(allchild(data.handles.magnitudeplot));
delete(allchild(data.handles.phaseplot));

switch action
    case 'loadsettings'
        set(data.handles.defineElement,'string','Loading Settings'); drawnow;
        
        [filename, pathname] = uigetfile('*.mat', 'Pick a .MAT file');
        
        if(filename == 0)
            otherButtons('enable');
            set(data.handles.defineElement,'string',''); drawnow;
            
            return
        end
        
        load(fullfile(pathname,filename));
        
        try
            data.discretisation = settings.discretisation;
            data.stabilitycriterion = settings.stabilitycriterion;
            data.controlarchitecture = settings.controlarchitecture;
            data.Name = settings.Name;
            data.parameters = settings.parameters;
            data.dynamics = settings.dynamics;
            data.stabilitycriterionFunction = settings.stabilitycriterionFunction;
            set(data.handles.(data.designcontrollers),'BackgroundColor',data.colourbutton);
            data.designcontrollers = settings.designcontrollers;
            stabilitycriterionsettings('stabilitycriterion_load',hObject,eventdata,handles);
            controlarchitectures('controlarchitecture_load',hObject,eventdata,handles);
            controlarchitectures('designcontrollers_load',hObject,eventdata,handles);
            
            Dynamics = data.dynamics.elements;
            for iZ = 1:1:2
                if(data.dynamics.(Dynamics{iZ}).XorV == 1)
                    set(data.handles.(Dynamics{iZ}),'String',['s',Dynamics{iZ}]);
                else
                    set(data.handles.(Dynamics{iZ}),'String',Dynamics{iZ});
                end
            end
            setSlaveMasterHandles('XeVe','Zs','e');
            setSlaveMasterHandles('XhVh','Zm','h');
            
            set(data.handles.name,'String',data.Name);
            
            set(data.handles.rectangles,'Value',0);
            set(data.handles.showinbode,'Value',0);
            set(data.handles.MagPhaseperSlider,'Value',log10(data.discretisation.minFreq));
            set(data.handles.MagPhaseperSlider,'Min',log10(data.discretisation.minFreq));
            set(data.handles.MagPhaseperSlider,'Max',log10(data.discretisation.maxFreq));
            if(isstr(data.discretisation.unitsFreq.String))
                data.discretisation.unitsFreq.String = {data.discretisation.unitsFreq.String};
            end
            if(isstr(data.discretisation.unitsMag.String))
                data.discretisation.unitsMag.String = {data.discretisation.unitsMag.String};
            end
            if(isstr(data.discretisation.unitsPhase.String))
                data.discretisation.unitsPhase.String = {data.discretisation.unitsPhase.String};
            end
            
            
            set(data.handles.Fhigh,'String',[num2str(data.discretisation.maxFreq),' ',...
                data.discretisation.unitsFreq.String{1}]);
            set(data.handles.Flow,'String',[num2str(data.discretisation.minFreq),' ',...
                data.discretisation.unitsFreq.String{1}]);
            set(data.handles.MPfreq,'String',[num2str(10^(get(data.handles.MagPhaseperSlider,'Value'))),' ',...
                data.discretisation.unitsFreq.String{1}]);
            
            
            otherButtons('enable');
            data.Design{1}.num = data.dynamics.(data.designcontrollers).Numerator;
            data.Design{1}.den = data.dynamics.(data.designcontrollers).Denominator;
            set(data.handles.numeratorcontroller,'String',data.dynamics.(data.designcontrollers).Numerator,'Enable','off');
            set(data.handles.denominatorcontroller,'String',data.dynamics.(data.designcontrollers).Denominator,'Enable','off');
            set(data.handles.controllerindex,'String',{data.designcontrollers},'Value',1,'Enable','off');
            set(data.handles.plotcontroller,'Enable','off');
            set(data.handles.designcontroller,'Enable','off');
            set(data.handles.stabilitycriteriontext,'Visible','off')
            set(data.handles.stabilitycriteriontext2,'Visible','off')
            set(data.handles.stabilityindicator,'Visible','off')
            set(data.handles.stabilityrangeindicator,'Visible','off')
            set(data.handles.resolution,'String',...
        [num2str((data.discretisation.maxMag-data.discretisation.minMag)/data.discretisation.nMag),' ',data.discretisation.unitsMag.String{1}, ' in Magnitude and ',...
        num2str((data.discretisation.maxPhase-data.discretisation.minPhase)/data.discretisation.nPhase),' ',data.discretisation.unitsPhase.String{1},' in Phase'])
            
            data.stepOfAction = [1 1];
            
        catch
            errorHandling('Invalid input');
            otherButtons('enable');
        end
        
    case 'loadfromworkspace'
        loadFromWorkspace(action,hObject,eventdata,handles)
        
    case 'loadmapping'
        set(data.handles.defineElement,'string','Loading Mapping'); drawnow;
        
        uiload
        try
            data.stabilityproperties = mapping.stabilityproperties;
            data.plot = mapping.plot;
            data.symController = mapping.symController;
            data.Controller = mapping.Controller;
            data.CurController = mapping.CurController;
            data.ListControllers = mapping.ListControllers;
            data.mapped = 1;
            data.plotController(1) = 1;
            data.plot.Magcontroller = {};
            data.plot.Phasecontroller = {};
            data.plot.Pointcontroller = {};
            data.dynamics = mapping.dynamics;
            
            plotDiagram(action,hObject,eventdata,handles);
            
            evaluateStability('final');
            
            otherButtons('enable');
            
            set(data.handles.plot3ddiagram,'Enable','on');
            set(data.handles.savemapping,'Enable','on');
            set(data.handles.designcontroller,'Enable','on');
            set(data.handles.plotcontroller,'Enable','on','Value',1);
            set(data.handles.plotfrequencyin,'Enable','on');
            set(data.handles.plotmagnitudein,'Enable','on');
            set(data.handles.plotphasein,'Enable','on');
            set(data.handles.MagPhaseperSlider,'Enable','on');
            set(data.handles.controllerindex,'Enable','on');
            set(data.handles.rectangles,'Enable','on');
            set(data.handles.showinbode,'Enable','on');
            set(data.handles.removecomponent,'Enable','on','Visible','on');
            
        catch
            errorHandling('Invalid input');
            otherButtons('enable');
        end
        
end

set(data.handles.showcomponents,'Enable','off','Visible','off');
set(data.handles.addcomponent,'Enable','off','Visible','off');
set(data.handles.removecomponent,'Enable','off','Visible','off');
set(data.handles.gainedit,'Enable','off','Visible','off');
set(data.handles.zeroedit,'Enable','off','Visible','off');
set(data.handles.dampzeroedit,'Enable','off','Visible','off');
set(data.handles.poleedit,'Enable','off','Visible','off');
set(data.handles.damppoleedit,'Enable','off','Visible','off');
set(data.handles.gaintext,'Enable','off','Visible','off');
set(data.handles.zerotext,'Enable','off','Visible','off');
set(data.handles.dampzerotext,'Enable','off','Visible','off');
set(data.handles.poletext,'Enable','off','Visible','off');
set(data.handles.damppoletext,'Enable','off','Visible','off');
set(data.handles.unitgain,'Enable','off','Visible','off');
set(data.handles.unitzero,'Enable','off','Visible','off');
set(data.handles.unitdampzero,'Enable','off','Visible','off');
set(data.handles.unitpole,'Enable','off','Visible','off');
set(data.handles.unitdamppole,'Enable','off','Visible','off');
set(data.handles.showcomponents,'Value',1);
set(data.handles.showcomponents,'String','Gain');
set(data.handles.defineElement,'string',''); drawnow;

return

function setSlaveMasterHandles(XV,Z,HE)
global data

if(data.dynamics.(Z).XorV == 1)
    set(data.handles.(XV),'String',['X',HE]);
    if(data.dynamics.(Z).ZorTf == 1)
        set(data.handles.(Z),'String',['1/(s',Z,')']);
    else
        set(data.handles.(Z),'String',['s',Z]);
    end
else
    set(data.handles.(XV),'String',['V',HE]);
    if(data.dynamics.(Z).ZorTf == 1)
        set(data.handles.(Z),'String',['1/',Z]);
    else
        set(data.handles.(Z),'String',Z);
    end
end

return

