%%
%
%
%%
function loadfromworkspace(varargin)
global data


Name = data.dynamics.temp.Name;
Abbreviation = data.dynamics.temp.Abbr;

try
    d = evalin('base','who');
    [u,v] = listdlg('PromptString',['Load continuous ',Name],...
        'SelectionMode','single',...
        'ListString',d,'Name','Select');
catch
    errorHandling('No elements in workspace');
    return
end
try
    dtest=evalin('base',d{u});
    
    if(isstr(dtest))
        data.dynamics.temp.(Abbreviation).Numerator = dtest;
        data.dynamics.temp.(Abbreviation).Denominator = '1';
    elseif(isa(dtest,'tf'))
        dtest2 = get(dtest);
        num = cell2mat(dtest2.num);
        den = cell2mat(dtest2.den);
        nD = length(num);
        dD = length(den);
        
        if(dD > 1)
            flagDen = 1;
            
            while (flagDen == 1)
                if(den(1) ~= 0)
                    dD = length(den);
                    flagDen = 0;
                else
                    den = den(:,2:end);
                    dD = dD-1;
                    if(dD == 1)
                        flagDen = 0;
                    end
                end
            end
        end
        if(nD > 1)
            flagNum = 1;
            
            while (flagNum == 1)
                if(num(1) ~= 0)
                    nD = length(num);
                    flagNum = 0;
                else
                    num = num(:,2:end);
                    nD = nD-1;
                    if(nD == 1)
                        flagNum = 0;
                    end
                end
            end
        end
        syms s;
        
        dtestStringNum = '';
        if(nD > 1)
            for iN = 1:1:nD
                dtestStringNum = strcat(dtestStringNum,'+(',num2str(num(iN)),')*s^(',num2str(nD-iN),')');
            end
            dtestStringNum = char(subs(dtestStringNum));
            
        else
            dtestStringNum = num2str(num);
        end
        
        dtestStringDen = '';
        if(dD > 1)
            for iD = 1:1:dD
                dtestStringDen = strcat(dtestStringDen,'+(',num2str(den(iD)),')*s^(',num2str(dD-iD),')');
            end
            dtestStringDen = char(subs(dtestStringDen));
        else
            dtestStringDen = num2str(den);
        end
        
        
        set(data.dynamics.temp.(Abbreviation).Numerator,'String',dtestStringNum);
        set(data.dynamics.temp.(Abbreviation).Denominator,'String',dtestStringDen);
    elseif(isnumeric(dtest))
        set(data.dynamics.temp.(Abbreviation).Numerator,'String',num2str(dtest));
        set(data.dynamics.temp.(Abbreviation).Denominator,'String',num2str(1));
    else
        errorHandling('Does not have proper input');
    end
    
catch
    return
end

return