%%
%
%
%%
function saveSettings(action,hObject,eventdata,handles)
global data
otherButtons('disable');

switch action
    case 'settings'
        set(data.handles.defineElement,'string','Saving Settings'); drawnow;
        
        h = figure;
        
        data.temp.h = h;
        
        hDesiredSize = [300, 110];
        set(h,'Resize','off','MenuBar','none','ToolBar','none','NumberTitle','off','Name',...
            ['Save Settings'],'Position',centerPopUp(hDesiredSize),...
            'Units','normalized','Color',[.9 .9 .9],'WindowStyle','modal');
        
        % Define text
        data.temp.saveName = uicontrol(h,'Style','edit','String',data.Name,'Units','normalized',...
            'Backgroundcolor',[1 1 1],'Position',[.15 .6 .7 .2],'FontSize',[10]);
        
        uicontrol(h,'Style','pushbutton','String','OK','Units','normalized',...
            'Backgroundcolor',data.colourbutton,'Callback',@returnToFunSettings,'FontSize',[11],...
            'Position',[.3 .3 .2 .2]);
        uicontrol(h,'Style','pushbutton','String','Cancel','Units','normalized',...
            'Position',[.55 .3 .2 .2],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
            'Callback','global data; closePopUp(data.temp.h);otherButtons(''enable''); clear data;');
    case 'mapping'
        if(data.mapped == 0)
            errorHandling('No mapping performed')
            return
        end
        set(data.handles.defineElement,'string','Saving Mapping Results'); drawnow;
        
        h = figure;
        
        data.temp.h = h;
        
        hDesiredSize = [300, 110];
        set(h,'Resize','off','MenuBar','none','ToolBar','none','NumberTitle','off','Name',...
            ['Save Settings'],'Position',centerPopUp(hDesiredSize),...
            'Units','normalized','Color',[.9 .9 .9],'WindowStyle','modal');
        
        % Define text
        data.temp.saveName = uicontrol(h,'Style','edit','String',[data.Name,'_MappingResults'],'Units','normalized',...
            'Backgroundcolor',[1 1 1],'Position',[.15 .6 .7 .2],'FontSize',[10]);
        
        uicontrol(h,'Style','pushbutton','String','OK','Units','normalized',...
            'Backgroundcolor',data.colourbutton,'Callback',@returnToFunMapping,'FontSize',[11],...
            'Position',[.3 .3 .2 .2]);
        uicontrol(h,'Style','pushbutton','String','Cancel','Units','normalized',...
            'Position',[.53 .3 .2 .2],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
            'Callback','global data; closePopUp(data.temp.h);otherButtons(''enable''); clear data;');
        
    case 'savecontroller'
        
        set(data.handles.defineElement,'string','Saving Controller Results'); drawnow;
        
        h = figure;
        
        data.temp.h = h;
        
        hDesiredSize = [300, 110];
        set(h,'Resize','off','MenuBar','none','ToolBar','none','NumberTitle','off','Name',...
            'Save Controller','Position',centerPopUp(hDesiredSize),...
            'Units','normalized','Color',[.9 .9 .9],'WindowStyle','modal');
        
        % Define text
        String = get(data.handles.controllerindex,'String');
        data.temp.saveName = uicontrol(h,'Style','popupmenu','String',...
            String(2:end),'Units','normalized',...
            'Backgroundcolor',[1 1 1],'Position',[.15 .7 .7 .2],'FontSize',[10]);
        data.temp.checkboxData = uicontrol(h,'Style','checkbox','String',...
            'All Data','Units','normalized',...
            'Backgroundcolor',[.9 .9 .9],'Position',[.15 .35 .7 .2],'FontSize',[10],'Value',1);
        data.temp.checkboxTf = uicontrol(h,'Style','checkbox','String',...
            'Transfer Function','Units','normalized',...
            'Backgroundcolor',[.9 .9 .9],'Position',[.55 .35 .7 .2],'FontSize',[10],'Value',1);
        
        uicontrol(h,'Style','pushbutton','String','OK','Units','normalized',...
            'Backgroundcolor',data.colourbutton,'Callback',@returnToFunController,'FontSize',[11],...
            'Position',[.3 .1 .2 .2]);
        uicontrol(h,'Style','pushbutton','String','Cancel','Units','normalized',...
            'Position',[.53 .1 .2 .2],'Backgroundcolor',data.colourbutton,'FontSize',[11],...
            'Callback','global data; closePopUp(data.temp.h);otherButtons(''enable''); clear data;');
end
return

function returnToFunSettings(varargin)
global data


try
    data.Name = get(data.temp.saveName,'String');
    
    settings = struct;
    settings.stabilitycriterion = data.stabilitycriterion;
    settings.stabilitycriterionFunction = data.stabilitycriterionFunction;
    settings.designcontrollers = data.designcontrollers;
    settings.controlarchitecture = data.controlarchitecture;
    settings.discretisation = data.discretisation;
    settings.dynamics = data.dynamics;
    settings.parameters = data.parameters;
    settings.Name = data.Name;
    
    save(get(data.temp.saveName,'String'),'settings');
catch
    errorHandling('No valid input')
end
closePopUp(data.temp.h);
otherButtons('enable');

return

function returnToFunMapping(varargin)
global data

try
    
    mapping = struct;
    mapping.stabilityproperties = data.stabilityproperties;
    mapping.plot = data.plot;
    mapping.symController = data.symController;
    mapping.Controller = data.Controller;
    mapping.CurController = data.CurController;
    mapping.ListControllers = data.ListControllers;
    mapping.plotController = 1;
    mapping.dynamics = data.dynamics;
    
    save(get(data.temp.saveName,'String'),'mapping');
catch
    errorHandling('No valid Input')
end
closePopUp(data.temp.h);
otherButtons('enable');

return

function returnToFunController(varargin)
global data

sortsComponents = get(data.handles.addcomponent,'String');

Names = get(data.temp.saveName,'String');
toSaveC = get(data.temp.saveName,'Value')+1;
saveName = Names{toSaveC-1};


if(get(data.temp.checkboxData,'Value') == 1)
    controller = data.Design{toSaveC};
    save(strcat(saveName,'_AllData'),'controller');
end

if(get(data.temp.checkboxTf,'Value') == 1)
    s = data.s;
    Ctf = struct;
    
    C = eval(data.Design{toSaveC}.num)/(eval(data.Design{toSaveC}.den));
    for i = 1:1:length(data.Design{toSaveC}.Components)-1
        [f1 f2 b1 b2 P D] = getEdit(i);
        
        if(data.Design{toSaveC}.Components{1}(i) == 1)
            num = str2num(data.Design{toSaveC}.gainValue{i});
            C = num*C;
        else
            num = data.Design{toSaveC}.ComponentsNum{i};
            den = data.Design{toSaveC}.ComponentsDen{i};
            repNum = subsComp(num,f1, f2, b1, b2, P, D);
            repDen = subsComp(den,f1, f2, b1, b2, P, D);
            C = C*(eval(repNum)/eval(repDen));            
        end
        
    end
    save(strcat(saveName,'_tf'),'C');
end


closePopUp(data.temp.h);
otherButtons('enable');
return








